without type_check
include opcodes.e
include val.e
include misc.e
sequence variables, stack, callstack, routines, code, codecode
integer ip, rp, rv
procedure disp()
    object val
    val = stack[length(stack)]
    stack = stack[1..length(stack)-1]
    if sequence(val) then
	puts(1,val)
    else
	? val
    end if
end procedure
procedure gttime()
    object val
    val = stack[length(stack)]
    stack = stack[1..length(stack)-1]
    variables[val] = time()
end procedure
constant oscalls = {routine_id("disp"),routine_id("gttime")}
procedure Setrvl(integer v)
    rv = v
end procedure
procedure Movll(integer v, object x)
    variables[v] = x
end procedure
procedure Movlv(integer v, integer x)
    variables[v] = variables[x]
end procedure
procedure Movdilll(integer v, object x, integer index)
    variables[v][index] = x
end procedure
procedure Movdilvv(integer v, integer x, integer index)
    variables[v][variables[index]] = variables[x]
end procedure
procedure Movdillv(integer v, object x, integer index)
    variables[v][variables[index]] = x
end procedure
procedure Movdilvl(integer v, integer x, integer index)
    variables[v][index] = variables[x]
end procedure
procedure Movsilll(integer v, sequence x, integer index)
    variables[v] = x[index]
end procedure
procedure Movsilvl(integer v, integer x, integer index)
    variables[v] = variables[x[index]]
end procedure
procedure Movsillv(integer v, sequence x, integer index)
    variables[v] = x[variables[index]]
end procedure
procedure Movsilvv(integer v, integer x, integer index)
    variables[v] = variables[x][variables[index]]
end procedure
procedure Addll(integer v, object x)
    variables[v] += x
end procedure
procedure Addlv(integer v, integer x)
    variables[v] += variables[x]
end procedure
procedure Subll(integer v, object x)
    variables[v] -= x
end procedure
procedure Sublv(integer v, integer x)
    variables[v] -= variables[x]
end procedure
procedure Mulll(integer v, object x)
    variables[v] *= x
end procedure
procedure Mullv(integer v, integer x)
    variables[v] *= variables[x]
end procedure
procedure Divll(integer v, object x)
    variables[v] /= x
end procedure
procedure Divlv(integer v, integer x)
    variables[v] /= variables[x]
end procedure
procedure Andll(integer v, object x)
    variables[v] = variables[v] and x
end procedure
procedure Andlv(integer v, integer x)
    variables[v] = variables[v] and variables[x]
end procedure
procedure Orll(integer v, object x)
    variables[v] = variables[v] or x
end procedure
procedure Orlv(integer v, integer x)
    variables[v] = variables[v] or variables[x]
end procedure
procedure Xorll(integer v, object x)
    variables[v] = variables[v] xor x
end procedure
procedure Xorlv(integer v, integer x)
    variables[v] = variables[v] xor variables[x]
end procedure
procedure Notl(integer v)
    variables[v] = not variables[v]
end procedure
procedure Movlenll(integer v, sequence x)
    variables[v] = length(x)
end procedure
procedure Movlenlv(integer v, integer x)
    variables[v] = length(variables[x])
end procedure
procedure Repeatll(integer v, integer count)
    variables[v] = repeat(variables[v],count)
end procedure
procedure Repeatlv(integer v, integer count)
    variables[v] = repeat(variables[v],variables[count])
end procedure
procedure Appendll(integer v, object x)
    variables[v] = append(variables[v],x)
end procedure
procedure Appendlv(integer v, integer x)
    variables[v] = append(variables[v],variables[x])
end procedure
procedure Prependll(integer v, object x)
    variables[v] = prepend(variables[v],x)
end procedure
procedure Prependlv(integer v, integer x)
    variables[v] = prepend(variables[v],variables[x])
end procedure
procedure Oscalll(integer x)
    call_proc(oscalls[x],{})
end procedure
procedure Oscallv(integer x)
    call_proc(oscalls[variables[x]],{})
end procedure
procedure Concenll(integer v, object x)
    variables[v] &= x
end procedure
procedure Concenlv(integer v, integer x)
    variables[v] &= variables[x]
end procedure
procedure Isintegerl(object x)
    variables[rv] = integer(x)
end procedure
procedure Isintegerv(integer x)
    variables[rv] = integer(variables[x])
end procedure
procedure Isatoml(object x)
    variables[rv] = atom(x)
end procedure
procedure Isatomv(integer x)
    variables[rv] = atom(variables[x])
end procedure
procedure Issequencel(object x)
    variables[rv] = sequence(x)
end procedure
procedure Issequencev(integer x)
    variables[rv] = sequence(variables[x])
end procedure
procedure Andbitsll(integer v, object x)
    variables[v] = and_bits(variables[v],x)
end procedure
procedure Andbitslv(integer v, integer x)
    variables[v] = and_bits(variables[v],variables[x])
end procedure
procedure Orbitsll(integer v, object x)
    variables[v] = or_bits(variables[v],x)
end procedure
procedure Orbitslv(integer v, integer x)
    variables[v] = or_bits(variables[v],variables[x])
end procedure
procedure Xorbitsll(integer v, object x)
    variables[v] = xor_bits(variables[v],x)
end procedure
procedure Xorbitslv(integer v, integer x)
    variables[v] = xor_bits(variables[v],variables[x])
end procedure
procedure Notbitsl(integer v)
    variables[v] = not_bits(variables[v])
end procedure
procedure Floorl(integer v)
    variables[v] = floor(variables[v])
end procedure
procedure Sqrtl(integer v)
    variables[v] = sqrt(v)
end procedure
procedure Remainderll(integer v, object x)
    variables[v] = remainder(variables[v],x)
end procedure
procedure Remainderlv(integer v, integer x)
    variables[v] = remainder(variables[v],variables[x])
end procedure
procedure Randll(integer v, integer max)
    variables[v] = rand(max)
end procedure
procedure Randlv(integer v, integer max)
    variables[v] = rand(variables[max])
end procedure
procedure Sinl(integer v)
    variables[v] = sin(variables[v])
end procedure
procedure Cosl(integer v)
    variables[v] = cos(variables[v])
end procedure
procedure Tanl(integer v)
    variables[v] = tan(variables[v])
end procedure
procedure Arcsinl(integer v)
    variables[v] = arcsin(variables[v])
end procedure
procedure Arccosl(integer v)
    variables[v] = arccos(variables[v])
end procedure
procedure Arctanl(integer v)
    variables[v] = arctan(variables[v])
end procedure
procedure Logl(integer v)
    variables[v] = log(v)
end procedure
procedure Powerll(integer v, object x)
    variables[v] = power(variables[v],x)
end procedure
procedure Powerlv(integer v, integer x)
    variables[v] = power(variables[v],variables[x])
end procedure
procedure Cell(atom a, atom b)
    variables[rv] = (a = b)
end procedure
procedure Cevl(integer a, atom b)
    variables[rv] = (variables[a] = b)
end procedure
procedure Celv(atom a, integer b)
    variables[rv] = (a = variables[b])
end procedure
procedure Cevv(integer a, integer b)
    variables[rv] = (variables[a] = variables[b])
end procedure
procedure Cnell(atom a, atom b)
    variables[rv] = (a != b)
end procedure
procedure Cnevl(integer a, atom b)
    variables[rv] = (variables[a] != b)
end procedure
procedure Cnelv(atom a, integer b)
    variables[rv] = (a != variables[b])
end procedure
procedure Cnevv(integer a, integer b)
    variables[rv] = (variables[a] != variables[b])
end procedure
procedure Clell(atom a, atom b)
    variables[rv] = (a <= b)
end procedure
procedure Clevl(integer a, atom b)
    variables[rv] = (variables[a] <= b)
end procedure
procedure Clelv(atom a, integer b)
    variables[rv] = (a <= variables[b])
end procedure
procedure Clevv(integer a, integer b)
    variables[rv] = (variables[a] <= variables[b])
end procedure
procedure Cgell(atom a, atom b)
    variables[rv] = (a >= b)
end procedure
procedure Cgevl(integer a, atom b)
    variables[rv] = (variables[a] >= b)
end procedure
procedure Cgelv(atom a, integer b)
    variables[rv] = (a >= variables[b])
end procedure
procedure Cgevv(integer a, integer b)
    variables[rv] = (variables[a] >= variables[b])
end procedure
procedure Clll(atom a, atom b)
    variables[rv] = (a < b)
end procedure
procedure Clvl(integer a, atom b)
    variables[rv] = (variables[a] < b)
end procedure
procedure Cllv(atom a, integer b)
    variables[rv] = (a < variables[b])
end procedure
procedure Clvv(integer a, integer b)
    variables[rv] = (variables[a] < variables[b])
end procedure
procedure Cgll(atom a, atom b)
    variables[rv] = (a > b)
end procedure
procedure Cgvl(integer a, atom b)
    variables[rv] = (variables[a] > b)
end procedure
procedure Cglv(atom a, integer b)
    variables[rv] = (a > variables[b])
end procedure
procedure Cgvv(integer a, integer b)
    variables[rv] = (variables[a] > variables[b])
end procedure
procedure Cmpll(object a, object b)
    variables[rv] = compare(a,b)
end procedure
procedure Cmpvl(integer a, object b)
    variables[rv] = compare(variables[a], b)
end procedure
procedure Cmplv(object a, integer b)
    variables[rv] = compare(a, variables[b])
end procedure
procedure Cmpvv(integer a, integer b)
    variables[rv] = compare(variables[a], variables[b])
end procedure
procedure Equll(object a, object b)
    variables[rv] = equal(a, b)
end procedure
procedure Equvl(integer a, object b)
    variables[rv] = equal(variables[a], b)
end procedure
procedure Equlv(object a, integer b)
    variables[rv] = equal(a, variables[b])
end procedure
procedure Equvv(integer a, integer b)
    variables[rv] = equal(variables[a], variables[b])
end procedure
procedure Ret()
    sequence s
    s = callstack[length(callstack)]
    callstack = callstack[1..length(callstack)-1]
    ip = s[1]
    rp = s[2]
    if rp = 0 then
	code = codecode
    else
	code = routines[rp]
    end if
end procedure
procedure Calll(integer r)
    callstack = append(callstack,{ip,rp})
    ip = 1
    rp = r
    code = routines[rp]
end procedure
procedure Callv(integer r)
    callstack = append(callstack,{ip,rp})
    ip = 1
    rp = variables[r]
    code = routines[rp]
end procedure
procedure Jmpl(integer x)
    ip = x
end procedure
procedure Jmpv(integer x)
    ip = variables[x]
end procedure
procedure Cjmpll(integer x, atom v)
    if v then
	ip = x
    end if
end procedure
procedure Cjmpvl(integer x, atom v)
    if v then
	ip = variables[x]
    end if
end procedure
procedure Cjmplv(integer x, integer v)
    if variables[v] then
	ip = x
    end if
end procedure
procedure Cjmpvv(integer x, integer v)
    if variables[v] then
	ip = variables[x]
    end if
end procedure
procedure End()
    abort(0)
end procedure
procedure Errl(integer x)
    printf(1,"ERROR: Error code %d\n",x)
end procedure
procedure Errv(integer x)
    printf(1,"ERROR: Error code %d\n",variables[x])
end procedure
procedure Pushl(object x)
    stack = append(stack,x)
end procedure
procedure Pushv(integer x)
    stack = append(stack,variables[x])
end procedure
procedure Popl(integer v)
    variables[v] = stack[length(stack)]
    stack = stack[1..length(stack)-1]
end procedure
procedure Ldssl(integer v)
    variables[v] = length(stack)
end procedure
constant UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
constant LOWER = "abcdefghijklmnopqrstuvwxyz"
function GenerateRoutineIDs()
    sequence s, name
    s = {}
    for i = 1 to length(OPCODES) do
	name = OPCODES[i][1]
	name[1] = UPPER[find(name[1],LOWER)]
	for j = 1 to length(OPCODES[i][3]) do
	    if OPCODES[i][3][j] = VAL then
		name &= 'l'
	    else
		name &= 'v'
	    end if
	end for
	s &= routine_id(name)
	if s[i] = -1 then
	    puts(1,"Couldn't find " & name & ".\n")
	    abort(0)
	end if
    end for
    return s
end function
constant ROUTINES = GenerateRoutineIDs()
procedure run()
    sequence c
    ip = 1
    rp = 0
    stack = {}
    callstack = {}
    code = codecode
    while get_key()=-1 do
	c = code[ip]
	ip += 1
	call_proc(c[1],c[2])
    end while
end procedure
procedure readCode(integer f, integer n)
    integer op
    sequence args
    code = {}
    if n then
	for i = 1 to n do
	    op = getc(f)
	    args = repeat(0,length(OPCODES[op+1][3]))
	    for j = 1 to length(args) do
		args[j] = ReadValue(f)
	    end for
	    code = append(code,{ROUTINES[op+1],args})
	end for
    else
	op = getc(f)
	while op != -1 do
	    args = repeat(0,length(OPCODES[op+1][3]))
	    for j = 1 to length(args) do
		args[j] = ReadValue(f)
	    end for
	    code = append(code,{ROUTINES[op+1],args})
	    op = getc(f)
	end while
    end if
end procedure
procedure loadFile(sequence s)
    integer f
    f = open(s,"rb")
    variables = repeat(0,ReadValue(f))
    routines = repeat(0,ReadValue(f))
    for i = 1 to length(routines) do
	readCode(f,ReadValue(f))
	routines[i] = code
    end for
    readCode(f,ReadValue(f))
    codecode = code
    close(f)
end procedure
sequence cl
cl = command_line()
puts(1,"Loading...\n")
loadFile(cl[3])
run()

